Index: molecuilder/src/periodentafel.cpp
===================================================================
--- molecuilder/src/periodentafel.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/periodentafel.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -8,9 +8,11 @@
 
 #include <iomanip>
+#include <iostream>
 #include <fstream>
 #include <cstring>
-#include <cassert>
-
+
+#include "Helpers/Assert.hpp"
 #include "element.hpp"
+#include "elements_db.hpp"
 #include "helpers.hpp"
 #include "lists.hpp"
@@ -27,5 +29,11 @@
  */
 periodentafel::periodentafel()
-{};
+{
+  ASSERT(LoadElementsDatabase(new stringstream(elementsDB,ios_base::in)), "General element initialization failed");
+  ASSERT(LoadValenceDatabase(new stringstream(valenceDB,ios_base::in)), "Valence entry of element initialization failed");
+  ASSERT(LoadOrbitalsDatabase(new stringstream(orbitalsDB,ios_base::in)), "Orbitals entry of element initialization failed");
+  ASSERT(LoadHBondAngleDatabase(new stringstream(HbondangleDB,ios_base::in)), "HBond angle entry of element initialization failed");
+  ASSERT(LoadHBondLengthsDatabase(new stringstream(HbonddistanceDB,ios_base::in)), "HBond distance entry of element initialization failed");
+};
 
 /** destructor for class periodentafel
@@ -39,10 +47,10 @@
 /** Adds element to period table list
  * \param *pointer element to be added
- * \return true - succeeded, false - does not occur
+ * \return iterator to added element
  */
 periodentafel::iterator periodentafel::AddElement(element * const pointer)
 {
   atomicNumber_t Z = pointer->getNumber();
-  assert(!elements.count(Z));
+  ASSERT(!elements.count(Z), "Element is already present.");
   pointer->sort = &pointer->Z;
   if (pointer->getNumber() < 1 && pointer->getNumber() >= MAX_ELEMENTS)
@@ -54,14 +62,19 @@
 /** Removes element from list.
  * \param *pointer element to be removed
- * \return true - succeeded, false - element not found
  */
 void periodentafel::RemoveElement(element * const pointer)
 {
-  atomicNumber_t Z = pointer->getNumber();
+  RemoveElement(pointer->getNumber());
+};
+
+/** Removes element from list.
+ * \param Z element to be removed
+ */
+void periodentafel::RemoveElement(atomicNumber_t Z)
+{
   elements.erase(Z);
 };
 
 /** Removes every element from the period table.
- * \return true - succeeded, false - does not occur
  */
 void periodentafel::CleanupPeriodtable()
@@ -78,5 +91,5 @@
  * \return pointer to element or NULL if not found
  */
-const element * periodentafel::FindElement(atomicNumber_t Z) const
+element * const periodentafel::FindElement(atomicNumber_t Z) const
 {
   const_iterator res = elements.find(Z);
@@ -89,5 +102,5 @@
  * \return pointer to element
  */
-const element * periodentafel::FindElement(const char * const shorthand) const
+element * const periodentafel::FindElement(const char * const shorthand) const
 {
   element *res = 0;
@@ -102,8 +115,9 @@
 
 /** Asks for element number and returns pointer to element
- */
-const element * periodentafel::AskElement() const
-{
-  const element *walker = NULL;
+ * \return desired element or NULL
+ */
+element * const periodentafel::AskElement() const
+{
+  element * walker = NULL;
   int Z;
   do {
@@ -118,16 +132,14 @@
  * \return pointer to either present or newly created element
  */
-const element * periodentafel::EnterElement()
-{
-  const element *res = NULL;
+element * const periodentafel::EnterElement()
+{
   atomicNumber_t Z = 0;
   DoLog(0) && (Log() << Verbose(0) << "Atomic number: " << Z << endl);
   cin >> Z;
-  res = FindElement(Z);
+  element * const res = FindElement(Z);
   if (!res) {
     // TODO: make this using the constructor
-    element *tmp;
     DoLog(0) && (Log() << Verbose(0) << "Element not found in database, please enter." << endl);
-    tmp = new element;
+    element *tmp = new element;
     tmp->Z = Z;
     DoLog(0) && (Log() << Verbose(0) << "Mass: " << endl);
@@ -138,5 +150,5 @@
     cin >> tmp->symbol;
     AddElement(tmp);
-    res = tmp;
+    return tmp;
   }
   return res;
@@ -204,7 +216,5 @@
 bool periodentafel::LoadPeriodentafel(const char *path)
 {
-  ifstream infile;
-  element *ptr;
-  map<atomicNumber_t,element*> parsedElems;
+  ifstream input;
   bool status = true;
   bool otherstatus = true;
@@ -215,34 +225,83 @@
   strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
   strncat(filename, STANDARDELEMENTSDB, MAXSTRINGSIZE-strlen(filename));
-  infile.open(filename);
-  if (infile != NULL) {
-    infile.getline(header1, MAXSTRINGSIZE);
-    infile.getline(header2, MAXSTRINGSIZE); // skip first two header lines
+  input.open(filename);
+  status = status && LoadElementsDatabase(&input);
+
+  // fill valence DB per element
+  strncpy(filename, path, MAXSTRINGSIZE);
+  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
+  strncat(filename, STANDARDVALENCEDB, MAXSTRINGSIZE-strlen(filename));
+  input.open(filename);
+  otherstatus = otherstatus && LoadValenceDatabase(&input);
+
+  // fill orbitals DB per element
+  strncpy(filename, path, MAXSTRINGSIZE);
+  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
+  strncat(filename, STANDARDORBITALDB, MAXSTRINGSIZE-strlen(filename));
+  input.open(filename);
+  otherstatus = otherstatus && LoadOrbitalsDatabase(&input);
+
+  // fill H-BondAngle DB per element
+  strncpy(filename, path, MAXSTRINGSIZE);
+  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
+  strncat(filename, STANDARDHBONDANGLEDB, MAXSTRINGSIZE-strlen(filename));
+  input.open(filename);
+  otherstatus = otherstatus && LoadHBondAngleDatabase(&input);
+
+  // fill H-BondDistance DB per element
+  strncpy(filename, path, MAXSTRINGSIZE);
+  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
+  strncat(filename, STANDARDHBONDDISTANCEDB, MAXSTRINGSIZE-strlen(filename));
+  input.open(filename);
+  otherstatus = otherstatus && LoadHBondLengthsDatabase(&input);
+
+  if (!otherstatus){
+    DoeLog(2) && (eLog()<< Verbose(2) << "Something went wrong while parsing the other databases!" << endl);
+  }
+
+  return status;
+};
+
+/** load the element info.
+ * \param *input stream to parse from
+ * \return true - parsing successful, false - something went wrong
+ */
+bool periodentafel::LoadElementsDatabase(istream *input)
+{
+  if ((*input) != NULL) {
+    (*input).getline(header1, MAXSTRINGSIZE);
+    (*input).getline(header2, MAXSTRINGSIZE); // skip first two header lines
     DoLog(0) && (Log() << Verbose(0) <<  "Parsed elements:");
-    while (!infile.eof()) {
+    while (!(*input).eof()) {
       element *neues = new element;
-      infile >> neues->name;
-      //infile >> ws;
-      infile >> neues->symbol;
-      //infile >> ws;
-      infile >> neues->period;
-      //infile >> ws;
-      infile >> neues->group;
-      //infile >> ws;
-      infile >> neues->block;
-      //infile >> ws;
-      infile >> neues->Z;
-      //infile >> ws;
-      infile >> neues->mass;
-      //infile >> ws;
-      infile >> neues->CovalentRadius;
-      //infile >> ws;
-      infile >> neues->VanDerWaalsRadius;
-      //infile >> ws;
-      infile >> ws;
+      (*input) >> neues->name;
+      //(*input) >> ws;
+      (*input) >> neues->symbol;
+      //(*input) >> ws;
+      (*input) >> neues->period;
+      //(*input) >> ws;
+      (*input) >> neues->group;
+      //(*input) >> ws;
+      (*input) >> neues->block;
+      //(*input) >> ws;
+      (*input) >> neues->Z;
+      //(*input) >> ws;
+      (*input) >> neues->mass;
+      //(*input) >> ws;
+      (*input) >> neues->CovalentRadius;
+      //(*input) >> ws;
+      (*input) >> neues->VanDerWaalsRadius;
+      //(*input) >> ws;
+      (*input) >> ws;
       DoLog(0) && (Log() << Verbose(0) << " " << neues->symbol);
+      if (elements.count(neues->Z)) {// if element already present, remove and delete it
+        element * const Elemental = FindElement(neues->Z);
+        ASSERT(Elemental != NULL, "element should be present but is not??");
+        RemoveElement(Elemental);
+        delete(Elemental);
+      }
       //neues->Output((ofstream *)&cout);
       if ((neues->Z > 0) && (neues->Z < MAX_ELEMENTS))
-        parsedElems[neues->getNumber()] = neues;
+        elements[neues->getNumber()] = neues;
       else {
         DoLog(0) && (Log() << Verbose(0) << "Could not parse element: ");
@@ -252,106 +311,104 @@
     }
     DoLog(0) && (Log() << Verbose(0) << endl);
-    infile.close();
-    infile.clear();
-  } else
-    status = false;
-
-  // fill valence DB per element
-  strncpy(filename, path, MAXSTRINGSIZE);
-  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
-  strncat(filename, STANDARDVALENCEDB, MAXSTRINGSIZE-strlen(filename));
-  infile.open(filename);
-  if (infile != NULL) {
-    while (!infile.eof()) {
+    return true;
+  } else
+    return false;
+}
+
+/** load the valence info.
+ * \param *input stream to parse from
+ * \return true - parsing successful, false - something went wrong
+ */
+bool periodentafel::LoadValenceDatabase(istream *input)
+{
+  char dummy[MAXSTRINGSIZE];
+  if ((*input) != NULL) {
+    (*input).getline(dummy, MAXSTRINGSIZE);
+    while (!(*input).eof()) {
       atomicNumber_t Z;
-      infile >> Z;
-      infile >> ws;
-      infile >> parsedElems[Z]->Valence;
-      infile >> ws;
+      (*input) >> Z;
+      ASSERT(elements.count(Z), "Element not present");
+      (*input) >> ws;
+      (*input) >> elements[Z]->Valence;
+      (*input) >> ws;
       //Log() << Verbose(3) << "Element " << (int)tmp << " has " << FindElement((int)tmp)->Valence << " valence electrons." << endl;
     }
-    infile.close();
-    infile.clear();
-  } else
-    otherstatus = false;
-
-  // fill valence DB per element
-  strncpy(filename, path, MAXSTRINGSIZE);
-  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
-  strncat(filename, STANDARDORBITALDB, MAXSTRINGSIZE-strlen(filename));
-  infile.open(filename);
-  if (infile != NULL) {
-    while (!infile.eof()) {
+    return true;
+  } else
+		return false;
+}
+
+/** load the orbitals info.
+ * \param *input stream to parse from
+ * \return true - parsing successful, false - something went wrong
+ */
+bool periodentafel::LoadOrbitalsDatabase(istream *input)
+{
+  char dummy[MAXSTRINGSIZE];
+  if ((*input) != NULL) {
+    (*input).getline(dummy, MAXSTRINGSIZE);
+    while (!(*input).eof()) {
       atomicNumber_t Z;
-      infile >> Z;
-      infile >> ws;
-      infile >> parsedElems[Z]->NoValenceOrbitals;
-      infile >> ws;
+      (*input) >> Z;
+      ASSERT(elements.count(Z), "Element not present");
+      (*input) >> ws;
+      (*input) >> elements[Z]->NoValenceOrbitals;
+      (*input) >> ws;
       //Log() << Verbose(3) << "Element " << (int)tmp << " has " << FindElement((int)tmp)->NoValenceOrbitals << " number of singly occupied valence orbitals." << endl;
     }
-    infile.close();
-    infile.clear();
-  } else
-    otherstatus = false;
-
-  // fill H-BondDistance DB per element
-  strncpy(filename, path, MAXSTRINGSIZE);
-  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
-  strncat(filename, STANDARDHBONDDISTANCEDB, MAXSTRINGSIZE-strlen(filename));
-  infile.open(filename);
-  if (infile != NULL) {
-    while (!infile.eof()) {
+    return true;
+  } else
+    return false;
+}
+
+/** load the hbond angles info.
+ * \param *input stream to parse from
+ * \return true - parsing successful, false - something went wrong
+ */
+bool periodentafel::LoadHBondAngleDatabase(istream *input)
+{
+  char dummy[MAXSTRINGSIZE];
+  if ((*input) != NULL) {
+    (*input).getline(dummy, MAXSTRINGSIZE);
+    while (!(*input).eof()) {
       atomicNumber_t Z;
-      infile >> Z;
-      ptr = parsedElems[Z];
-      infile >> ws;
-      infile >> ptr->HBondDistance[0];
-      infile >> ptr->HBondDistance[1];
-      infile >> ptr->HBondDistance[2];
-      infile >> ws;
+      (*input) >> Z;
+      ASSERT(elements.count(Z), "Element not present");
+      (*input) >> ws;
+      (*input) >> elements[Z]->HBondAngle[0];
+      (*input) >> elements[Z]->HBondAngle[1];
+      (*input) >> elements[Z]->HBondAngle[2];
+      (*input) >> ws;
+      //Log() << Verbose(3) << "Element " << (int)tmp << " has " << FindElement((int)tmp)->HBondAngle[0] << ", " << FindElement((int)tmp)->HBondAngle[1] << ", " << FindElement((int)tmp)->HBondAngle[2] << " degrees bond angle for one, two, three connected hydrogens." << endl;
+    }
+    return true;
+  } else
+		return false;
+}
+
+/** load the hbond lengths info.
+ * \param *input stream to parse from
+ * \return true - parsing successful, false - something went wrong
+ */
+bool periodentafel::LoadHBondLengthsDatabase(istream *input)
+{
+  char dummy[MAXSTRINGSIZE];
+  if ((*input) != NULL) {
+    (*input).getline(dummy, MAXSTRINGSIZE);
+    while (!(*input).eof()) {
+      atomicNumber_t Z;
+      (*input) >> Z;
+      ASSERT(elements.count(Z), "Element not present");
+      (*input) >> ws;
+      (*input) >> elements[Z]->HBondDistance[0];
+      (*input) >> elements[Z]->HBondDistance[1];
+      (*input) >> elements[Z]->HBondDistance[2];
+      (*input) >> ws;
       //Log() << Verbose(3) << "Element " << (int)tmp << " has " << FindElement((int)tmp)->HBondDistance[0] << " Angstrom typical distance to hydrogen." << endl;
     }
-    infile.close();
-    infile.clear();
-  } else
-    otherstatus = false;
-
-  // fill H-BondAngle DB per element
-  strncpy(filename, path, MAXSTRINGSIZE);
-  strncat(filename, "/", MAXSTRINGSIZE-strlen(filename));
-  strncat(filename, STANDARDHBONDANGLEDB, MAXSTRINGSIZE-strlen(filename));
-  infile.open(filename);
-  if (infile != NULL) {
-    while (!infile.eof()) {
-      atomicNumber_t Z;
-      infile >> Z;
-      ptr = parsedElems[Z];
-      infile >> ws;
-      infile >> ptr->HBondAngle[0];
-      infile >> ptr->HBondAngle[1];
-      infile >> ptr->HBondAngle[2];
-      infile >> ws;
-      //Log() << Verbose(3) << "Element " << (int)tmp << " has " << FindElement((int)tmp)->HBondAngle[0] << ", " << FindElement((int)tmp)->HBondAngle[1] << ", " << FindElement((int)tmp)->HBondAngle[2] << " degrees bond angle for one, two, three connected hydrogens." << endl;
-    }
-    infile.close();
-  } else
-    otherstatus = false;
-
-  if (otherstatus){
-    map<atomicNumber_t,element*>::iterator iter;
-    for(iter=parsedElems.begin();iter!=parsedElems.end();++iter){
-      AddElement((*iter).second);
-    }
-  }
-  else{
-    DoeLog(2) && (eLog()<< Verbose(2) << "Something went wrong while parsing the other databases!" << endl);
-    map<atomicNumber_t,element*>::iterator iter;
-    for(iter=parsedElems.begin();iter!=parsedElems.end();++iter){
-      AddElement((*iter).second);
-    }
-  }
-
-  return status;
-};
+    return true;
+  } else
+		return false;
+}
 
 /** Stores element list to file.
@@ -374,6 +431,6 @@
     }
     f.close();
-  } else
-    result = false;
-  return result;
-};
+    return true;
+  } else
+    return result;
+};
Index: molecuilder/src/periodentafel.hpp
===================================================================
--- molecuilder/src/periodentafel.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/periodentafel.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -13,4 +13,5 @@
 #include <iterator>
 
+#include "unittests/periodentafelTest.hpp"
 #include "defs.hpp"
 #include "types.hpp"
@@ -27,4 +28,5 @@
 class periodentafel {
   /******* Types *********/
+  friend class periodentafelTest;
   private:
     typedef std::map<atomicNumber_t,element*> elementSet;
@@ -43,9 +45,10 @@
   iterator AddElement(element * const pointer);
   void RemoveElement(element * const pointer);
+  void RemoveElement(atomicNumber_t);
   void CleanupPeriodtable();
-  const element *FindElement(atomicNumber_t) const;
-  const element *FindElement(const char * const shorthand) const;
-  const element *AskElement() const;
-  const element *EnterElement();
+  element * const FindElement(atomicNumber_t) const;
+  element * const FindElement(const char * const shorthand) const;
+  element * const AskElement() const;
+  element * const EnterElement();
 
   const_iterator begin();
@@ -59,4 +62,11 @@
 
   private:
+
+  bool LoadElementsDatabase(std::istream *input);
+  bool LoadValenceDatabase(std::istream *input);
+  bool LoadOrbitalsDatabase(std::istream *input);
+  bool LoadHBondAngleDatabase(std::istream *input);
+  bool LoadHBondLengthsDatabase(std::istream *input);
+
     elementSet elements;
 };
Index: molecuilder/src/tesselation.cpp
===================================================================
--- molecuilder/src/tesselation.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/tesselation.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -83,5 +83,5 @@
 ostream & operator <<(ostream &ost, const BoundaryPointSet &a)
 {
-  ost << "[" << a.Nr << "|" << a.node->Name << " at " << *a.node->node << "]";
+  ost << "[" << a.Nr << "|" << a.node->getName() << " at " << *a.node->node << "]";
   return ost;
 }
@@ -321,5 +321,5 @@
 ostream & operator <<(ostream &ost, const BoundaryLineSet &a)
 {
-  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << " at " << *a.endpoints[0]->node->node << "," << a.endpoints[1]->node->Name << " at " << *a.endpoints[1]->node->node << "]";
+  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->getName() << " at " << *a.endpoints[0]->node->node << "," << a.endpoints[1]->node->getName() << " at " << *a.endpoints[1]->node->node << "]";
   return ost;
 }
@@ -688,5 +688,5 @@
 ostream &operator <<(ostream &ost, const BoundaryTriangleSet &a)
 {
-  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << "," << a.endpoints[1]->node->Name << "," << a.endpoints[2]->node->Name << "]";
+  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->getName() << "," << a.endpoints[1]->node->getName() << "," << a.endpoints[2]->node->getName() << "]";
   //  ost << "[" << a.Nr << "|" << a.endpoints[0]->node->Name << " at " << *a.endpoints[0]->node->node << ","
   //      << a.endpoints[1]->node->Name << " at " << *a.endpoints[1]->node->node << "," << a.endpoints[2]->node->Name << " at " << *a.endpoints[2]->node->node << "]";
@@ -948,5 +948,5 @@
   ost << "[" << a.Nr << "|";
   for (PointSet::const_iterator Runner = a.endpoints.begin(); Runner != a.endpoints.end();) {
-    ost << (*Runner)->node->Name;
+    ost << (*Runner)->node->getName();
     Runner++;
     if (Runner != a.endpoints.end())
@@ -967,5 +967,4 @@
   node = NULL;
   nr = -1;
-  Name = NULL;
 }
 ;
@@ -983,5 +982,5 @@
 ostream & operator <<(ostream &ost, const TesselPoint &a)
 {
-  ost << "[" << (a.Name) << "|" << a.Name << " at " << *a.node << "]";
+  ost << "[" << a.getName() << "|" << *a.node << "]";
   return ost;
 }
@@ -1135,5 +1134,5 @@
 ostream & operator <<(ostream &ost, const CandidateForTesselation &a)
 {
-  ost << "[" << a.BaseLine->Nr << "|" << a.BaseLine->endpoints[0]->node->Name << "," << a.BaseLine->endpoints[1]->node->Name << "] with ";
+  ost << "[" << a.BaseLine->Nr << "|" << a.BaseLine->endpoints[0]->node->getName() << "," << a.BaseLine->endpoints[1]->node->getName() << "] with ";
   if (a.pointlist.empty())
     ost << "no candidate.";
@@ -1348,13 +1347,13 @@
       if (fabs(distance) < 1e-4) // we need to have a small epsilon around 0 which is still ok
         continue;
-      DoLog(2) && (Log() << Verbose(2) << "Projection of " << checker->second->node->Name << " yields distance of " << distance << "." << endl);
+      DoLog(2) && (Log() << Verbose(2) << "Projection of " << checker->second->node->getName() << " yields distance of " << distance << "." << endl);
       tmp = distance / fabs(distance);
       // 4b. Any have different sign to than before? (i.e. would lie outside convex hull with this starting triangle)
       if ((sign != 0) && (tmp != sign)) {
         // 4c. If so, break 4. loop and continue with next candidate in 1. loop
-        DoLog(2) && (Log() << Verbose(2) << "Current candidates: " << A->second->node->Name << "," << baseline->second.first->second->node->Name << "," << baseline->second.second->second->node->Name << " leaves " << checker->second->node->Name << " outside the convex hull." << endl);
+        DoLog(2) && (Log() << Verbose(2) << "Current candidates: " << A->second->node->getName() << "," << baseline->second.first->second->node->getName() << "," << baseline->second.second->second->node->getName() << " leaves " << checker->second->node->getName() << " outside the convex hull." << endl);
         break;
       } else { // note the sign for later
-        DoLog(2) && (Log() << Verbose(2) << "Current candidates: " << A->second->node->Name << "," << baseline->second.first->second->node->Name << "," << baseline->second.second->second->node->Name << " leave " << checker->second->node->Name << " inside the convex hull." << endl);
+        DoLog(2) && (Log() << Verbose(2) << "Current candidates: " << A->second->node->getName() << "," << baseline->second.first->second->node->getName() << "," << baseline->second.second->second->node->getName() << " leave " << checker->second->node->getName() << " inside the convex hull." << endl);
         sign = tmp;
       }
@@ -4292,5 +4291,5 @@
         DoLog(2) && (Log() << Verbose(2) << "INFO: MiddleNode is " << **MiddleNode << "." << endl);
         DoLog(2) && (Log() << Verbose(2) << "INFO: EndNode is " << **EndNode << "." << endl);
-        DoLog(1) && (Log() << Verbose(1) << "INFO: Attempting to create triangle " << (*StartNode)->Name << ", " << (*MiddleNode)->Name << " and " << (*EndNode)->Name << "." << endl);
+        DoLog(1) && (Log() << Verbose(1) << "INFO: Attempting to create triangle " << (*StartNode)->getName() << ", " << (*MiddleNode)->getName() << " and " << (*EndNode)->getName() << "." << endl);
         TriangleCandidates[0] = *StartNode;
         TriangleCandidates[1] = *MiddleNode;
@@ -4714,5 +4713,5 @@
     return;
   }
-  DoLog(0) && (Log() << Verbose(0) << "Nearest point on boundary is " << NearestPoint->Name << "." << endl);
+  DoLog(0) && (Log() << Verbose(0) << "Nearest point on boundary is " << NearestPoint->getName() << "." << endl);
 
   // go through its lines and find the best one to split
@@ -4799,8 +4798,10 @@
   ofstream *tempstream = NULL;
   string NameofTempFile;
-  char NumberName[255];
+  string NumberName;
 
   if (LastTriangle != NULL) {
-    sprintf(NumberName, "-%04d-%s_%s_%s", (int) TrianglesOnBoundary.size(), LastTriangle->endpoints[0]->node->Name, LastTriangle->endpoints[1]->node->Name, LastTriangle->endpoints[2]->node->Name);
+    stringstream sstr;
+    sstr << "-"<< TrianglesOnBoundary.size() << "-" << LastTriangle->endpoints[0]->node->getName() << "_" << LastTriangle->endpoints[1]->node->getName() << "_" << LastTriangle->endpoints[2]->node->getName();
+    NumberName = sstr.str();
     if (DoTecplotOutput) {
       string NameofTempFile(filename);
Index: molecuilder/src/tesselationhelpers.cpp
===================================================================
--- molecuilder/src/tesselationhelpers.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/tesselationhelpers.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -829,5 +829,5 @@
       if (TesselStruct->LastTriangle != NULL) {
         for (int i=0;i<3;i++)
-          *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->Name;
+          *tecplot << (i==0 ? "" : "_") << TesselStruct->LastTriangle->endpoints[i]->node->getName();
       } else {
         *tecplot << "none";
@@ -852,5 +852,5 @@
     DoLog(1) && (Log() << Verbose(1) << "The following triangles were created:" << endl);
     for (TriangleMap::const_iterator runner = TesselStruct->TrianglesOnBoundary.begin(); runner != TesselStruct->TrianglesOnBoundary.end(); runner++) {
-      DoLog(1) && (Log() << Verbose(1) << " " << runner->second->endpoints[0]->node->Name << "<->" << runner->second->endpoints[1]->node->Name << "<->" << runner->second->endpoints[2]->node->Name << endl);
+      DoLog(1) && (Log() << Verbose(1) << " " << runner->second->endpoints[0]->node->getName() << "<->" << runner->second->endpoints[1]->node->getName() << "<->" << runner->second->endpoints[2]->node->getName() << endl);
       *tecplot << LookupList[runner->second->endpoints[0]->node->nr] << " " << LookupList[runner->second->endpoints[1]->node->nr] << " " << LookupList[runner->second->endpoints[2]->node->nr] << endl;
     }
Index: molecuilder/src/unittests/AnalysisCorrelationToPointUnitTest.cpp
===================================================================
--- molecuilder/src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/AnalysisCorrelationToPointUnitTest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -17,12 +17,9 @@
 #include "AnalysisCorrelationToPointUnitTest.hpp"
 
-#include "World.hpp"
 #include "atom.hpp"
-#include "boundary.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
 #include "linkedcell.hpp"
 #include "periodentafel.hpp"
-#include "tesselation.hpp"
 #include "World.hpp"
 
@@ -43,22 +40,11 @@
   TestList = NULL;
   TestMolecule = NULL;
-  hydrogen = NULL;
-  tafel = NULL;
   pointmap = NULL;
   binmap = NULL;
   point = NULL;
 
-  // construct element
-  hydrogen = new element;
-  hydrogen->Z = 1;
-  strcpy(hydrogen->name, "hydrogen");
-  strcpy(hydrogen->symbol, "H");
-
-
-  // construct periodentafel
-  tafel = World::getInstance().getPeriode();
-  tafel->AddElement(hydrogen);
-
   // construct molecule (tetraeder of hydrogens)
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
+  CPPUNIT_ASSERT(hydrogen != NULL && "hydrogen element not found");
   TestMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
Index: molecuilder/src/unittests/AnalysisCorrelationToPointUnitTest.hpp
===================================================================
--- molecuilder/src/unittests/AnalysisCorrelationToPointUnitTest.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/AnalysisCorrelationToPointUnitTest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -12,9 +12,6 @@
 
 class element;
-class LinkedCell;
 class molecule;
 class MoleculeListClass;
-class periodentafel;
-class Tesselation;
 class Vector;
 
@@ -40,6 +37,5 @@
       MoleculeListClass *TestList;
       molecule *TestMolecule;
-      element *hydrogen;
-      periodentafel *tafel;
+      const element *hydrogen;
 
       CorrelationToPointMap *pointmap;
Index: molecuilder/src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp
===================================================================
--- molecuilder/src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/AnalysisCorrelationToSurfaceUnitTest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -17,5 +17,4 @@
 #include "AnalysisCorrelationToSurfaceUnitTest.hpp"
 
-#include "World.hpp"
 #include "atom.hpp"
 #include "boundary.hpp"
@@ -47,6 +46,4 @@
   TestList = NULL;
   TestSurfaceMolecule = NULL;
-  hydrogen = NULL;
-  tafel = NULL;
   surfacemap = NULL;
   binmap = NULL;
@@ -54,20 +51,6 @@
   LC = NULL;
 
-  // construct element
-  hydrogen = new element;
-  hydrogen->Z = 1;
-  strcpy(hydrogen->name, "hydrogen");
-  strcpy(hydrogen->symbol, "H");
-  carbon = new element;
-  carbon->Z = 6;
-  strcpy(carbon->name, "carbon");
-  strcpy(carbon->symbol, "C");
-
-  // construct periodentafel
-  tafel = World::getInstance().getPeriode();
-  tafel->AddElement(hydrogen);
-  tafel->AddElement(carbon);
-
   // construct molecule (tetraeder of hydrogens) base
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
   TestSurfaceMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
@@ -102,4 +85,5 @@
 
   // add outer atoms
+  carbon = World::getInstance().getPeriode()->FindElement(6);
   TestSurfaceMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
Index: molecuilder/src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp
===================================================================
--- molecuilder/src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/AnalysisCorrelationToSurfaceUnitTest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -45,7 +45,6 @@
       MoleculeListClass *TestList;
       molecule *TestSurfaceMolecule;
-      element *hydrogen;
-      element *carbon;
-      periodentafel *tafel;
+      const element *hydrogen;
+      const element *carbon;
 
       CorrelationToSurfaceMap *surfacemap;
Index: molecuilder/src/unittests/AnalysisPairCorrelationUnitTest.cpp
===================================================================
--- molecuilder/src/unittests/AnalysisPairCorrelationUnitTest.cpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/AnalysisPairCorrelationUnitTest.cpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -44,20 +44,9 @@
   TestList = NULL;
   TestMolecule = NULL;
-  hydrogen = NULL;
-  tafel = NULL;
   correlationmap = NULL;
   binmap = NULL;
 
-  // construct element
-  hydrogen = new element;
-  hydrogen->Z = 1;
-  strcpy(hydrogen->name, "hydrogen");
-  strcpy(hydrogen->symbol, "H");
-
-  // construct periodentafel
-  tafel = World::getInstance().getPeriode();
-  tafel->AddElement(hydrogen);
-
   // construct molecule (tetraeder of hydrogens)
+  hydrogen = World::getInstance().getPeriode()->FindElement(1);
   TestMolecule = World::getInstance().createMolecule();
   Walker = World::getInstance().createAtom();
Index: molecuilder/src/unittests/AnalysisPairCorrelationUnitTest.hpp
===================================================================
--- molecuilder/src/unittests/AnalysisPairCorrelationUnitTest.hpp	(revision 3561800616d100e40c39e5a93b9765d260e50b0f)
+++ molecuilder/src/unittests/AnalysisPairCorrelationUnitTest.hpp	(revision 5cf5a4a0464b8f54c442bbc4192cc9df792dd368)
@@ -12,9 +12,6 @@
 
 class element;
-class LinkedCell;
 class molecule;
 class MoleculeListClass;
-class periodentafel;
-class Tesselation;
 class Vector;
 
@@ -40,6 +37,5 @@
       MoleculeListClass *TestList;
       molecule *TestMolecule;
-      element *hydrogen;
-      periodentafel *tafel;
+      const element *hydrogen;
 
       PairCorrelationMap *correlationmap;
